<template>
	<div class="absolute w-full lg:sticky top-18 md:-mx-10 lg:-mx-0 lg:mr-10 z-50">
		<nav id="side-nav" aria-label="Left">
			<div
				class="bg-white text-base font-primary-font-bold lg:hidden flex justify-between items-center px-4 md:px-6 py-2 md:py-4 border-b border-grey-20"
			>
				<span @keydown.enter="$emit('toggle', !maskToggle)"> {{ title }}</span
				><button
					:aria-expanded="[!maskToggle ? false : true]"
					:aria-label="title"
					:class="[
						!maskToggle
							? 'icon-right-arrow focus:outline-none focus:ring-1 focus:ring-black'
							: 'icon-down-arrow focus:outline-none focus:ring-1 focus:ring-black',
					]"
					@click="$emit('toggle', !maskToggle)"
				></button>
			</div>
			<div
				v-show="maskToggle"
				class="shadow-lg lg:shadow-none lg:w-240 bg-white lg:bg-transparent lg:block z-50"
				:class="screenWidth <= 768 ? 'my-0' : 'my-0'"
			>
				<div
					v-for="(item, index) in nav_title"
					:id="item.id"
					:key="index"
					class="flex flex-col px-4 md:px-6 lg:px-0 lg:py-0"
					:class="screenWidth <= 768 && navTitle == item.text ? '' : 'py-2 md:py-4'"
					:text="item.text"
					@click="changeTitle(index)"
					@keydown.enter="changeTitle(index)"
				>
					<NuxtLink
						v-if="screenWidth > 768"
						:to="item.page"
						class="font-primary-font-light text-base leading-6 lg:pb-6"
						:class="{ 'active-nuxt-link': item.text == navTitle }"
					>
						{{ item.text }}
					</NuxtLink>
					<NuxtLink
						v-if="screenWidth <= 768 && navTitle != item.text"
						:to="item.page"
						class="font-primary-font-light text-base leading-6 lg:pb-6 ml-4"
						:class="{ 'active-nuxt-link': item.text == navTitle }"
					>
						{{ item.text }}
					</NuxtLink>
				</div>
				<div class="flex flex-col cursor-pointer">
					<a
						href="https://help.molekule.com/hc/en-us"
						class="font-primary-font-light text-base leading-6 px-4 md:px-6 lg:px-0 py-2 lg:py-0 lg:pb-6 md:py-4"
						:class="screenWidth <= 768 ? 'ml-4' : ''"
						>Help</a
					>
					<a
						href="javascript:;"
						aria-labelledby="logout_success_message"
						class="font-primary-font-light text-base leading-6 px-4 md:px-6 lg:px-0 py-2 lg:py-0 md:py-4 pb-6 md:pb-6"
						:class="screenWidth <= 768 ? 'ml-4' : ''"
						@click="logout"
						>Log out</a
					>
					<p
						id="logout_success_message"
						ref="logout_success_message"
						role="alert"
						aria-live="polite"
						class="sr-only"
					></p>
				</div>
			</div>
		</nav>
	</div>
</template>

<script>
import { mapState } from 'vuex';
export default {
	name: 'Mknavbar',
	components: {},
	props: {
		maskToggle: {
			type: Boolean,
			default: true,
		},
	},
	data() {
		return {
			title: 'Dashboard',
			logoutSuccessText: 'You have been successfully logged out',
			screenWidth: window.innerWidth,
			nav_title: [
				{
					id: 'accMgmt_dashboard_txt',
					text: 'Dashboard',
					page: '/D2C/account/dashboard/',
					visibility: [],
				},
				{
					id: 'accMgmt_auto_refills_txt',
					text: 'Auto-refills',
					page: '/D2C/account/autoRefills/',
					visibility: ['UK'],
				},
				{
					id: 'accMgmt_order_txt',
					text: 'Orders',
					page: '/D2C/account/order/',
					visibility: [],
				},
				{
					id: 'accMgmt_address_payment_txt',
					text: 'Address & Payment',
					page: '/D2C/account/addressPayment/',
					visibility: [],
				},
				{
					id: 'accMgmt_share_txt',
					text: 'Share Molekule',
					page: '/D2C/account/shareMolekule/',
					visibility: ['UK'],
				},
				{
					id: 'accMgmt_profile_txt',
					text: 'Profile',
					page: '/D2C/account/profile/',
					visibility: [],
				},
			],
		};
	},
	computed: {
		...mapState(['isEurope']),
		navTitle: {
			get() {
				return this.title;
			},
			set(newTitle) {
				return (this.title = newTitle);
			},
		},
	},
	watch: {
		maskToggle() {
			this.$emit('toggle', this.maskToggle);
		},
	},
	created() {
		if (this.$route.path) {
			const $path = this.$route.path;
			const $index = this.nav_title.findIndex(function (obj) {
				return $path.includes(obj.page);
			});
			if ($index > -1) {
				this.navTitle = this.nav_title[$index].text;
			}
		}
	},
	mounted() {
		// document.addEventListener('click', this.handleClickOutside)
		const $parent = this;
		window.addEventListener('resize', function (event) {
			$parent.screenWidth = window.innerWidth;
		});
		if (this.screenWidth <= 768) {
			this.$emit('toggle', false);
		}
		if (this.isEurope) {
			this.nav_title = this.nav_title.filter((item) => !item.visibility.length);
		}
	},
	methods: {
		handleClickOutside(evt) {
			if (!this.$el.contains(evt.target)) {
				this.$emit('toggle', false);
			}
		},
		async logout() {
			const self = this;
			await this.$store.dispatch('USER_STORE/SIGN_OUT', { path: '/' });
			this.$store.dispatch('USER_STORE/EXIST_USER_ALERT');
			self.$refs.logout_success_message.textContent = this.logoutSuccessText;
		},
		changeTitle(index) {
			this.navTitle = this.nav_title[index].text;
			if (this.screenWidth <= 768) {
				this.$emit('toggle', false);
			}
		},
		showTitle() {
			this.$emit('toggle', !this.maskToggle);
		},
	},
};
</script>
<style lang="postcss">
.nuxt-link-exact-active {
	@apply font-primary-font-bold;
}
.active-nuxt-link {
	@apply font-primary-font-bold;
}
</style>
